package com.javacodegeeks;

import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.TimeUnit;

public class ScheduledTaskExample {

    public static void main(String[] args) {
        ScheduledExecutorService scheduledExecutorService = Executors.newSingleThreadScheduledExecutor();

        Callable<Integer> scheduledTask = new Callable<Integer>() {
            public Integer call() {
                try {
                    Thread.sleep(5000);
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
                return 100;
            }
        };

        Future<Integer> output = scheduledExecutorService.schedule(scheduledTask, 5, TimeUnit.SECONDS);

        try {
            Integer value = output.get();
            System.out.println("### Value is " + value);
        } catch (InterruptedException | ExecutionException e) {
            e.printStackTrace();
        }

        scheduledExecutorService.shutdown();
    }
}
